function varargout = Wigwams_dataset_GUI(varargin)
% WIGWAMS_DATASET_GUI MATLAB code for Wigwams_dataset_GUI.fig
%      WIGWAMS_DATASET_GUI, by itself, creates a new WIGWAMS_DATASET_GUI or raises the existing
%      singleton*.
%
%      H = WIGWAMS_DATASET_GUI returns the handle to a new WIGWAMS_DATASET_GUI or the handle to
%      the existing singleton*.
%
%      WIGWAMS_DATASET_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in WIGWAMS_DATASET_GUI.M with the given input arguments.
%
%      WIGWAMS_DATASET_GUI('Property','Value',...) creates a new WIGWAMS_DATASET_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Wigwams_dataset_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Wigwams_dataset_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Wigwams_dataset_GUI

global exprname
global exprpath
global dataset
global degname
global degpath
global degs_present
degs_present = 1;

% Last Modified by GUIDE v2.5 06-Mar-2013 11:01:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Wigwams_dataset_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @Wigwams_dataset_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Wigwams_dataset_GUI is made visible.
function Wigwams_dataset_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Wigwams_dataset_GUI (see VARARGIN)

% Choose default command line output for Wigwams_dataset_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Wigwams_dataset_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Wigwams_dataset_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function dataset_name_Callback(hObject, eventdata, handles)
% hObject    handle to dataset_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dataset_name as text
%        str2double(get(hObject,'String')) returns contents of dataset_name as a double


% --- Executes during object creation, after setting all properties.
function dataset_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dataset_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in import_degs.
function import_degs_Callback(hObject, eventdata, handles)
% hObject    handle to import_degs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global degname
global degpath

[degname degpath] = uigetfile('.txt');
if ~isempty(degname)
    set(handles.import_degs,'BackgroundColor','green');
end

% --- Executes on button press in filter_genes.
function filter_genes_Callback(hObject, eventdata, handles)
% hObject    handle to filter_genes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in generate_seeds.
function generate_seeds_Callback(hObject, eventdata, handles)
% hObject    handle to generate_seeds (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in save_dataset.
function save_dataset_Callback(hObject, eventdata, handles)
% hObject    handle to save_dataset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global dataset
global degs_present

%check for dataset unit
toggle=0;
set(handles.stresscount,'ForegroundColor','black');
set(handles.exprstext,'ForegroundColor','black');
if isempty(get(handles.exprs,'String'))
    set(handles.exprstext,'ForegroundColor','red');
    toggle=1;
end
if str2num(get(handles.stresscount,'String'))==0
    set(handles.stresscount,'ForegroundColor','red');
    toggle=1;
end

if toggle==1
    return;
else
    dataset.unit = get(handles.exprs,'String');
end

%so, here we are - saving the dataset.
[savename savepath] = uiputfile('.mat');

%cancels happen
if isempty(savename)
    return
end

%if no cancel, we are going in.
set(handles.save_dataset,'BackgroundColor','yellow');
drawnow

%assuming degs are in place, filtering and proper seed genes
if degs_present == 1
    %remove all non-deg genes
    numtemp = 1:size(dataset.degs,1);
    numtemp = numtemp(sum(dataset.degs,2)==0);
    dataset.submatrix(numtemp,:)=[];
    dataset.genes(numtemp)=[];
    dataset.degs(numtemp,:)=[];
    %seed genes
    numtemp = 1:size(dataset.degs,1);
    SeedGenes = numtemp(sum(dataset.degs,2)>1);
    %convert degs to double
    dataset.degs = +dataset.degs;
    %create second dataset and shuffle its non-DEG profiles around
    dataset2 = dataset;
    numtemp = 1:length(dataset.genes);
    number_of_conditions = length(dataset.conditions);
    condition_range = zeros(number_of_conditions,3);
    condition_range(1,1) = 1;
    for i=1:number_of_conditions
        condition_range(i,3) = length(dataset.timepoints{i});
        condition_range(i,2) = condition_range(i,1)+condition_range(i,3)-1;
        if i<number_of_conditions
            condition_range(i+1,1) = condition_range(i,2)+1;
        end
    end
    for i=1:length(dataset.conditions)
        nondegs = numtemp(dataset.degs(:,i)==0);
        nondegs2 = nondegs(randperm(length(nondegs)));
        dataset2.submatrix(nondegs2,condition_range(i,1):condition_range(i,2)) = ...
            dataset.submatrix(nondegs,condition_range(i,1):condition_range(i,2));
    end
else
    %every gene is a seed gene now
    SeedGenes = 1:length(dataset.genes);
end

save([savepath savename],'dataset','SeedGenes');
if exist('dataset2','var')
    dataset3 = dataset;
    dataset = dataset2;
    save([savepath savename(1:end-4) '_shuffled' savename(end-3:end)],...
        'dataset','SeedGenes');
    dataset = dataset3;
    clear dataset3;
end
set(handles.save_dataset,'BackgroundColor','green');
set(handles.savedto,'String',['dataset successfully saved to ',savepath,savename]);

function stress_name_Callback(hObject, eventdata, handles)
% hObject    handle to stress_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of stress_name as text
%        str2double(get(hObject,'String')) returns contents of stress_name as a double


% --- Executes during object creation, after setting all properties.
function stress_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to stress_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function timepoints_Callback(hObject, eventdata, handles)
% hObject    handle to timepoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of timepoints as text
%        str2double(get(hObject,'String')) returns contents of timepoints as a double


% --- Executes during object creation, after setting all properties.
function timepoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to timepoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function unit_Callback(hObject, eventdata, handles)
% hObject    handle to unit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of unit as text
%        str2double(get(hObject,'String')) returns contents of unit as a double


% --- Executes during object creation, after setting all properties.
function unit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to unit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in import_expression.
function import_expression_Callback(hObject, eventdata, handles)
% hObject    handle to import_expression (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global exprname
global exprpath

[exprname exprpath] = uigetfile('.txt');
if ~isempty(exprname)
    set(handles.import_expression,'BackgroundColor','green');
end

function replicates_Callback(hObject, eventdata, handles)
% hObject    handle to replicates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of replicates as text
%        str2double(get(hObject,'String')) returns contents of replicates as a double


% --- Executes during object creation, after setting all properties.
function replicates_CreateFcn(hObject, eventdata, handles)
% hObject    handle to replicates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in sort1.
function sort1_Callback(hObject, eventdata, handles)
% hObject    handle to sort1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sort1

%the second button gets toggled off
set(handles.sort2,'Value',0);

% --- Executes on button press in sort2.
function sort2_Callback(hObject, eventdata, handles)
% hObject    handle to sort2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sort2

%the second button gets toggled off
set(handles.sort1,'Value',0);


% --- Executes on button press in save_stress.
function save_stress_Callback(hObject, eventdata, handles)
% hObject    handle to save_stress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global exprname
global exprpath
global degname
global degpath
global dataset
global degs_present

%null out any possible colorings from prior attempts
set(handles.stresstext,'ForegroundColor','black');
set(handles.timepointtitle,'ForegroundColor','black');
set(handles.unittext,'ForegroundColor','black');
set(handles.replicatetest,'ForegroundColor','black');
set(handles.sort1,'ForegroundColor','black');
set(handles.sort2,'ForegroundColor','black');
set(handles.startpostext,'ForegroundColor','black');
if get(handles.procmenu,'Value')==3
    set(handles.widthtext,'ForegroundColor','black');
    set(handles.repvartext,'ForegroundColor','black');
    set(handles.timevartext,'ForegroundColor','black');
end

%check if all the values are sorted out
toggle = 0;
if isempty(get(handles.stress_name,'String'))
    set(handles.stresstext,'ForegroundColor','red');
    toggle = 1;
end
if isempty(exprname) || isempty(exprpath)
    set(handles.import_expression,'BackgroundColor','red');
    toggle = 1;
end
if isempty(get(handles.timepoints,'String'))
    set(handles.timepointtitle,'ForegroundColor','red');
    toggle = 1;
end
if isempty(get(handles.unit,'String'))
    set(handles.unittext,'ForegroundColor','red');
    toggle = 1;
end
if isempty(get(handles.replicates,'String'))
    set(handles.replicatetest,'ForegroundColor','red');
    toggle = 1;
else
    replicates = str2num(get(handles.replicates,'String'));
end
if get(handles.sort1,'Value') == 0 && get(handles.sort2,'Value') == 0
    if exist('replicates','var')
        if replicates ~= 1
            set(handles.sort1,'ForegroundColor','red');
            set(handles.sort2,'ForegroundColor','red');
            toggle = 1;
        end
    else
        set(handles.sort1,'ForegroundColor','red');
        set(handles.sort2,'ForegroundColor','red');
    end
end
if isempty(get(handles.startpos,'String'))
    set(handles.startpostext,'ForegroundColor','red');
    toggle = 1;
end
if get(handles.procmenu,'Value')==3
    if isempty(get(handles.width,'String'))
        set(handles.widthtext,'ForegroundColor','red');
        toggle = 1;
    end
    if isempty(get(handles.repvar,'String'))
        set(handles.repvartext,'ForegroundColor','red');
        toggle = 1;
    end
    if isempty(get(handles.timevar,'String'))
        set(handles.timevartext,'ForegroundColor','red');
        toggle = 1;
    end
end
if (isempty(degname) || isempty(degpath)) && degs_present == 1 && toggle == 0
    answer = questdlg('You have not imported a list of DEGs for this stress. Do you wish to continue?');
    if ~strcmp(answer,'Yes')
        set(handles.import_degs,'BackgroundColor','red');
        toggle = 1;
    end
end
if toggle == 1
    return
end

%if the code got here, time to save stuff
color_hold = [0.9294 0.9294 0.9294];

%in progress
set(handles.save_stress,'BackgroundColor','yellow');
drawnow

%blank the dataset, just in case of why not
if str2num(get(handles.stresscount,'String'))==0
    dataset = struct;
end

timepoints=str2num(get(handles.timepoints,'String'));
%split the start position into the letter (column) and number (row)
startpos = get(handles.startpos,'String');
i=1;
while startpos(i)>=65 && startpos(i)<=90
    i=i+1;
end
startposcol = startpos(1:i-1);
startposrow = str2num(startpos(i:end));

%figure out the effective range to import from the text file
%replicates is already defined, if the toggle didn't break it
totlength = replicates*length(timepoints);
initialcol = letter_number_parser(startposcol,2);
finalposcol = letter_number_parser(initialcol+totlength-1,1);

%get number of rows, and list of genes at the same time
fid = fopen([exprpath exprname]);

%first startposrow-1 lines are trash
for i=1:startposrow-1
    fgetl(fid);
end

genes = cell(0);
j=1;
while ~feof(fid)
    linehold = fgetl(fid);
    i = 1;
    %double(tab) = 9
    while double(linehold(i)) ~= 9
        i = i+1;
    end
    if i>1
        genes{j} = linehold(1:i-1);
    end
    j = j+1;
end

fclose(fid);

%now, knowing how many genes we had and what row we started from, we can
%compute the final positioning
finalposrow = startposrow+length(genes)-1;
%sure, there may be more lines in the file than gene names, but without a
%gene name the line is useless anyway

%now we can create the call parameter
callparameter = [startposcol,num2str(startposrow),'..',...
    finalposcol,num2str(finalposrow)];
%and import the expression
exprs = dlmread([exprpath exprname],'\t',callparameter);

%time to compare the gene list against the dataset to filter out the genes
%that are not present in all sets
%sorting of gene list and exprs. note upper as a form of case insensitivity
genes_upper = upper(genes);
[genes_upper inds] = sort(genes_upper);
genes = genes(inds);
exprs = exprs(inds,:);
%dataset empty? you get to dictate the trend
if isempty(fieldnames(dataset))
    dataset.genes = genes;
else
    newtemp = 1:length(genes);
    oldtemp = 1:length(dataset.genes);
    %uppers as a form of case-insensitivity
    newtemp = newtemp(~ismember(genes_upper,upper(dataset.genes)));
    oldtemp = oldtemp(~ismember(upper(dataset.genes),genes_upper));
    %remove the appropriate expression values
    if ~isempty(newtemp)
        exprs(newtemp,:)=[];
    end
    if ~isempty(oldtemp)
        dataset.submatrix(oldtemp,:)=[];
    end
end

%everything is nice and sorted, and unified in the respect of dataset vs
%new stress. now we get to mean up the data and standardize it, and then
%apply it to the dataset structure
nice_exprs = zeros(size(exprs,1),length(timepoints));
%toggle on sorting
if replicates == 1
    %nothing to do
    nice_exprs = exprs;
    for i=1:size(nice_exprs,1)
        %since I'm in here already, let's standardize
        nice_exprs(i,:) = (nice_exprs(i,:)-mean(nice_exprs(i,:)))/std(nice_exprs(i,:));
    end
elseif get(handles.sort1,'Value') == 1
    %entire repeats stacked after each other
    for i=1:size(nice_exprs,1)
        for j=1:replicates
            temp(j,:) = exprs(i,(j-1)*length(timepoints)+1:j*length(timepoints));
        end
        switch get(handles.procmenu,'Value')
            case 1
                nice_exprs(i,:) = mean(temp);
            case 2
                nice_exprs(i,:) = median(temp);
            case 3
                kernel = gauss2d(replicates, ...
                    2*str2num(get(handles.width,'String'))+1, ...
                    str2num(get(handles.repvar,'String')), ...
                    str2num(get(handles.timevar,'String')));
                nice_exprs(i,:) = WideMean(temp,kernel);
        end
        %since I'm in here already, let's standardize
        nice_exprs(i,:) = (nice_exprs(i,:)-mean(nice_exprs(i,:)))/std(nice_exprs(i,:));
    end
else
    %timepoints stacked after each other
    for i=1:size(nice_exprs,1)
        for j=1:length(timepoints)
            temp(:,j) = exprs(i,(j-1)*replicates+1:j*replicates)';
        end
        switch get(handles.procmenu,'Value')
            case 1
                nice_exprs(i,:) = mean(temp);
            case 2
                nice_exprs(i,:) = median(temp);
            case 3
                kernel = gauss2d(replicates, ...
                    2*str2num(get(handles.width,'String'))+1, ...
                    str2num(get(handles.repvar,'String')), ...
                    str2num(get(handles.timevar,'String')));
                nice_exprs(i,:) = WideMean(temp,kernel);
        end
        %since I'm in here already, let's standardize
        nice_exprs(i,:) = (nice_exprs(i,:)-mean(nice_exprs(i,:)))/std(nice_exprs(i,:));
    end
end

%handle degs
if (isempty(degname) || isempty(degpath)) && degs_present == 1
    %no degs. no more degs either
    degs_present = 0;
    set(handles.import_degs,'Enable','off');
    if isfield(dataset,'degs')
        dataset=rmfield(dataset,'degs');
    end
else
    %import degs
    fid = fopen([degpath degname]);
    i=1;
    degs=cell(0);
    while ~feof(fid)
        degs{i} = fgetl(fid);
        i=i+1;
    end
    fclose(fid);
end

%which stress is this?
stress_number = str2num(get(handles.stresscount,'String'))+1;

%have nice expression stuff, time to print stuff to the structure
if ~isfield(dataset,'submatrix')
    dataset.submatrix = nice_exprs;
else
    dataset.submatrix = [dataset.submatrix nice_exprs];
end
dataset.conditions{stress_number} = get(handles.stress_name,'String');
dataset.timepoints{stress_number} = timepoints';   %' to column them up
dataset.timescale{stress_number} = get(handles.unit,'String');
if degs_present == 1
    dataset.degs(:,stress_number) = ismember(upper(dataset.genes),upper(degs));
end

%update display
set(handles.saved_msg,'String',[dataset.conditions{stress_number},' successfully saved!']);
set(handles.stresscount,'String',num2str(stress_number));
set(handles.stress_name,'String','');
set(handles.timepoints,'String','');
set(handles.unit,'String','');
set(handles.import_expression,'BackgroundColor',color_hold);
set(handles.import_degs,'BackgroundColor',color_hold);
set(handles.save_stress,'BackgroundColor',color_hold);
set(handles.startpos,'String','');
set(handles.replicates,'String','');
set(handles.stresscount,'ForegroundColor','black');

%wipe paths
exprname = '';
exprpath = '';
degname = '';
degpath = '';

function startpos_Callback(hObject, eventdata, handles)
% hObject    handle to startpos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of startpos as text
%        str2double(get(hObject,'String')) returns contents of startpos as a double


% --- Executes during object creation, after setting all properties.
function startpos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to startpos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function exprs_Callback(hObject, eventdata, handles)
% hObject    handle to exprs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of exprs as text
%        str2double(get(hObject,'String')) returns contents of exprs as a double


% --- Executes during object creation, after setting all properties.
function exprs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to exprs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in procmenu.
function procmenu_Callback(hObject, eventdata, handles)
% hObject    handle to procmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns procmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from procmenu

if get(handles.procmenu,'Value')==3
    set(handles.repvartext,'Visible','on');
    set(handles.repvar,'Visible','on');
    set(handles.timevartext,'Visible','on');
    set(handles.timevar,'Visible','on');
    set(handles.widthtext,'Visible','on');
    set(handles.width,'Visible','on');
else
    set(handles.repvartext,'Visible','off');
    set(handles.repvar,'Visible','off');
    set(handles.timevartext,'Visible','off');
    set(handles.timevar,'Visible','off');
    set(handles.widthtext,'Visible','off');
    set(handles.width,'Visible','off');
end

% --- Executes during object creation, after setting all properties.
function procmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to procmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function width_Callback(hObject, eventdata, handles)
% hObject    handle to width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of width as text
%        str2double(get(hObject,'String')) returns contents of width as a double


% --- Executes during object creation, after setting all properties.
function width_CreateFcn(hObject, eventdata, handles)
% hObject    handle to width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function repvar_Callback(hObject, eventdata, handles)
% hObject    handle to repvar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of repvar as text
%        str2double(get(hObject,'String')) returns contents of repvar as a double


% --- Executes during object creation, after setting all properties.
function repvar_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repvar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function timevar_Callback(hObject, eventdata, handles)
% hObject    handle to timevar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of timevar as text
%        str2double(get(hObject,'String')) returns contents of timevar as a double


% --- Executes during object creation, after setting all properties.
function timevar_CreateFcn(hObject, eventdata, handles)
% hObject    handle to timevar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
