function out = letter_number_parser(in,mode)
%Inputs:
%   * in - the number or letters in question
%   * mode - 1 for numbers to letters, 2 for letters to numbers
%
%It should be noted that A=0,...,Z=25,AA-26,... and so on in this fashion

if mode == 1
    %from number to letter. A=0,...,Z=25,AA=26,....
    %not a simple numbering system. 26 single digits, 26*26 double digits, 
    %26*26*26 triple digits etc
    i=1;
    in2=in;
    while in2 >= 26^i
        in2 = in2-26^i;
        i=i+1;
    end
    %kewl. now we've got i = number of digits, and in2 = scaled number for
    %that given digit-set
    for j=i:-1:1
        out(i-j+1) = floor(in2/(26^(j-1)));
        in2 = in2-out(i-j+1)*26^(j-1);
    end
    %and now convert to char
    out = char(65+out);
else
    %from letter to number. A=0,...,Z=25,AA=26,....
    %close the gap - add a power of 26 for each letter present
    out = 0;
    for i=2:length(in)
        out = out+26^(i-1);
    end
    %now add the normal values
    for i=1:length(in)
        out = out+(double(in(length(in)-i+1))-65)*26^(i-1);
    end
end